SystemOrganization addCategory: #'SDL-Specs-NB'!

SDLCodeGenerator subclass: #SDLNBCodeGenerator
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SDL-Specs-NB'!

!SDLNBCodeGenerator methodsFor: 'FFI code generation' stamp: 'NickAlexander 1/1/2012 18:55'!
functionsInto: aStream forClass: aClassName 
	aStream nextPutAll: 'Object subclass: #' , aClassName , '
	instanceVariableNames: ''''
	classVariableNames: ''''
	poolDictionaries: ''''
	category: ''' , self category , '''. !!';
		 cr;
		 cr.
	api functions
		do: [:fn | 
			aStream nextPut: $!!;
				 nextPutAll: aClassName;
				 nextPutAll: ' methodsFor: ''';
				 nextPutAll: fn headerFileName;
				 nextPutAll: ''' stamp: ''';
				 nextPutAll: Author changeStamp;
				 nextPutAll: '''!!';
				 cr.
			aStream
				nextPutAll: (self sourceForFunction: fn).
			aStream nextPutAll: '!! !!';
				 cr]! !

!SDLNBCodeGenerator methodsFor: 'FFI code generation' stamp: 'NickAlexander 1/8/2012 17:32'!
handlesInto: aStream forClass: aClassName 
	aStream cr; nextPutAll: 'NBExternalObject subclass: #' , aClassName , 'ExternalHandle' , '
	instanceVariableNames: ''''
	classVariableNames: ''''
	poolDictionaries: ''''
	category: ''' , self category , '''. !!'; cr; cr.
	self handles do: [ :h | aStream cr; nextPutAll: aClassName , 'ExternalHandle subclass: #' , h, '
	instanceVariableNames: ''''
	classVariableNames: ''''
	poolDictionaries: ''''
	category: ''' , self category , '''. !!'; cr; cr]! !

!SDLNBCodeGenerator methodsFor: 'FFI code generation' stamp: 'NickAlexander 1/1/2012 21:34'!
innerTypeNameFor: aName
	aName = 'char*' ifTrue: [ ^ 'String'. ].
	api missingTypes
		at: aName
		ifPresent: [:v | ^ v].
	api enums
		at: aName
		ifPresent: [:v | ^ #long ].
	api structs
		at: aName
		ifPresent: [:v | ^ aName].
	api unions
		at: aName
		ifPresent: [:v | ^ aName].
	aName last = $*
		ifTrue: [^ (self innerTypeNameFor: aName allButLast), '*'].
	"self error: 'unknown type ', aName."
	^ aName! !

!SDLNBCodeGenerator methodsFor: 'accessing' stamp: 'NickAlexander 1/1/2012 19:10'!
prefixString
	^ 'NB'! !

!SDLNBCodeGenerator methodsFor: 'FFI code generation' stamp: 'NickAlexander 1/1/2012 19:48'!
sourceForFunction: fn
	^ String
		streamContents: [:str |
			str
				nextPutAll: fn name.
			fn params keys notEmpty
				ifTrue: [ str
					nextPutAll: ': ';
					nextPutAll: fn params keys first ].
			fn params keys
				allButFirstDo: [:param | str
					nextPutAll: ' ';
					nextPutAll: param;
					nextPutAll: ': ';
					nextPutAll: param ].

			str
				crtab;
				nextPutAll: '"This method was automatically generated from SDL 1.3 headers"';
				crtab;
				nextPutAll: '"See http://squeaksource.com/SDLSpecs for details"';
				crtab;
				nextPutAll: '<primitive: #primitiveNativeCall module: #NativeBoostPlugin>';
				crtab;
				nextPutAll: '^ NBFFICallout cdecl: #(';
				nextPutAll: (self typeNameFor: fn returnType);
				nextPutAll: ' ';
				nextPutAll: fn name;
				nextPutAll: '('.
			fn params keys
				do: [:param | str
						crtab;
						nextPutAll: (self typeNameFor: (fn params at: param));
						nextPutAll: ' ';
						nextPutAll: param;
						nextPutAll: ','
						
				].
			str crtab nextPutAll: ')) module: #SDL13_32'.
]! !

!SDLNBCodeGenerator methodsFor: 'FFI code generation' stamp: 'NickAlexander 1/1/2012 19:03'!
sourceForStruct: struct
	^ String
		streamContents: [:str | 
			str nextPutAll: 'fieldsDesc';
				 crtab;
				 nextPutAll: '"This method was automatically generated from SDL 1.3 headers"';
				 crtab;
				 nextPutAll: '"See http://squeaksource.com/SDLSpecs for details"';
				 crtab;
				 nextPutAll: '^ #('.
			struct valueNames
				keysAndValuesDo: [:k :v | str crtab; tab;
					nextPutAll: (self typeNameFor: v);
					nextPutAll: ' ';
					nextPutAll: k; 
					nextPutAll: ';'
			].
			str crtab nextPutAll: ')';
				 crtab;
				 crtab]! !

!SDLNBCodeGenerator methodsFor: 'FFI code generation' stamp: 'NickAlexander 1/1/2012 18:50'!
structsInto: aStream forClass: aClassName 

	aStream nextPutAll: 'NBExternalStructure variableByteSubclass: #' , aClassName , 'ExternalStructure
	instanceVariableNames: ''''
	classVariableNames: ''''
	poolDictionaries: ''''
	category: ''' , self category , '''. !!';
		 cr;
		 cr.
	aStream nextPutAll: aClassName , 'ExternalStructure subclass: #' , aClassName , 'AbstractEvent
	instanceVariableNames: ''''
	classVariableNames: ''''
	poolDictionaries: ''''
	category: ''' , self category , '''. !!';
		 cr;
		 cr.
	api structs
		do: [:e | 
			aStream nextPutAll: ((e name endsWith: 'Event')
					ifTrue: [aClassName , 'AbstractEvent']
					ifFalse: [aClassName , 'ExternalStructure'])
					, ' variableByteSubclass: #' , e name , '
	instanceVariableNames: ''''
	classVariableNames: ''''
	poolDictionaries: ''''
	category: ''' , self category , '''. !!';
				 cr.
			aStream nextPut: $!!;
				 nextPutAll: e name , ' class';
				 nextPutAll: ' methodsFor: ''';
				 nextPutAll: e headerFileName;
				 nextPutAll: ''' stamp: ''';
				 nextPutAll: Author changeStamp;
				 nextPutAll: '''!!';
				 cr.
			aStream
				nextPutAll: (self sourceForStruct: e).
			aStream nextPutAll: '!! !!';
				 cr].
	api structs
		keysDo: [:k | aStream cr; nextPutAll: k , ' initializeAccessors. !!'].
	aStream cr; cr; nextPutAll: 'SDL_MouseMotionEvent variableByteSubclass: #SDL_Event
	instanceVariableNames: ''''
	classVariableNames: ''''
	poolDictionaries: ''''
	category: ''' , self category , '''. !!'; cr; cr! !

!SDLNBCodeGenerator methodsFor: 'FFI code generation' stamp: 'NickAlexander 1/1/2012 21:31'!
typeNameFor: aName 
	| nm type |
	nm := self innerTypeNameFor: aName.
	type := NBFFICallout new resolveType: nm.
	(type pointerArity > 0 and: [ type isKindOf: NBExternalObjectType ]) ifTrue: [
		(type pointerArity > 1)
			ifTrue: [ self error: 'cannot use NativeBoost with type ', aName ].
		^ type objectClass asString
	].
	(nm includes: $*)
		ifTrue: [ ^ $' asString, nm, $' asString ].
	^ nm! !
